Line length: Fix recent merges
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Copyright (c) 2021 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             if [[ ${SELECTION_MODE} == "--test" ]]; then
295                 EXPANDED_TAGS+=("--test" "${tag}")
296             else
297                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
298             fi
299         fi
300     done
301
302     if [[ ${SELECTION_MODE} == "--test" ]]; then
303         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
304     fi
305 }
306
307
308 function deactivate_docker_topology () {
309
310     # Deactivate virtual vpp-device topology by removing containers.
311     #
312     # Variables read:
313     # - NODENESS - Node multiplicity of desired testbed.
314     # - FLAVOR - Node flavor string, usually describing the processor.
315
316     set -exuo pipefail
317
318     case_text="${NODENESS}_${FLAVOR}"
319     case "${case_text}" in
320         "1n_skx" | "1n_tx2")
321             ssh="ssh root@172.17.0.1 -p 6022"
322             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
323             # The "declare -f" output is long and boring.
324             set +x
325             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
326                 die "Topology cleanup via shim-dcr failed!"
327             }
328             set -x
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     # We sort the directories, so log output can be compared between runs.
400     file_list=$("${cmd_line[@]}" | sort) || die
401
402     for gen in ${file_list}; do
403         directory="$(dirname "${gen}")" || die
404         filename="$(basename "${gen}")" || die
405         pushd "${directory}" || die
406         ./"${filename}" || die
407         popd || die
408     done
409 }
410
411
412 function get_test_code () {
413
414     # Arguments:
415     # - ${1} - Optional, argument of entry script (or empty as unset).
416     #   Test code value to override job name from environment.
417     # Variables read:
418     # - JOB_NAME - String affecting test selection, default if not argument.
419     # Variables set:
420     # - TEST_CODE - The test selection string from environment or argument.
421     # - NODENESS - Node multiplicity of desired testbed.
422     # - FLAVOR - Node flavor string, usually describing the processor.
423
424     set -exuo pipefail
425
426     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
427     if [[ -z "${TEST_CODE}" ]]; then
428         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
429     fi
430
431     case "${TEST_CODE}" in
432         *"1n-vbox"*)
433             NODENESS="1n"
434             FLAVOR="vbox"
435             ;;
436         *"1n-skx"*)
437             NODENESS="1n"
438             FLAVOR="skx"
439             ;;
440        *"1n-tx2"*)
441             NODENESS="1n"
442             FLAVOR="tx2"
443             ;;
444         *"2n-aws"*)
445             NODENESS="2n"
446             FLAVOR="aws"
447             ;;
448         *"3n-aws"*)
449             NODENESS="3n"
450             FLAVOR="aws"
451             ;;
452         *"2n-skx"*)
453             NODENESS="2n"
454             FLAVOR="skx"
455             ;;
456         *"2n-zn2"*)
457             NODENESS="2n"
458             FLAVOR="zn2"
459             ;;
460         *"3n-skx"*)
461             NODENESS="3n"
462             FLAVOR="skx"
463             ;;
464         *"2n-clx"*)
465             NODENESS="2n"
466             FLAVOR="clx"
467             ;;
468         *"2n-dnv"*)
469             NODENESS="2n"
470             FLAVOR="dnv"
471             ;;
472         *"3n-dnv"*)
473             NODENESS="3n"
474             FLAVOR="dnv"
475             ;;
476         *"2n-tx2"*)
477             NODENESS="2n"
478             FLAVOR="tx2"
479             ;;
480         *"3n-tsh"*)
481             NODENESS="3n"
482             FLAVOR="tsh"
483             ;;
484         *)
485             # Fallback to 3-node Haswell by default (backward compatibility)
486             NODENESS="3n"
487             FLAVOR="hsw"
488             ;;
489     esac
490 }
491
492
493 function get_test_tag_string () {
494
495     # Variables read:
496     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
497     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
498     # - TEST_CODE - The test selection string from environment or argument.
499     # Variables set:
500     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
501     #   May be empty, or even not set on event types not adding comment.
502
503     # TODO: ci-management scripts no longer need to perform this.
504
505     set -exuo pipefail
506
507     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
508         case "${TEST_CODE}" in
509             *"device"*)
510                 trigger="devicetest"
511                 ;;
512             *"perf"*)
513                 trigger="perftest"
514                 ;;
515             *)
516                 die "Unknown specification: ${TEST_CODE}"
517         esac
518         # Ignore lines not containing the trigger word.
519         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
520         # The vpp-csit triggers trail stuff we are not interested in.
521         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
522         # (except relying on \s whitespace, \S non-whitespace and . both).
523         # The last string is concatenated, only the middle part is expanded.
524         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
525         # On parsing error, TEST_TAG_STRING probably stays empty.
526         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
527         if [[ -z "${TEST_TAG_STRING-}" ]]; then
528             # Probably we got a base64 encoded comment.
529             comment="${GERRIT_EVENT_COMMENT_TEXT}"
530             comment=$(base64 --decode <<< "${comment}" || true)
531             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
532             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
533         fi
534         if [[ -n "${TEST_TAG_STRING-}" ]]; then
535             test_tag_array=(${TEST_TAG_STRING})
536             if [[ "${test_tag_array[0]}" == "icl" ]]; then
537                 export GRAPH_NODE_VARIANT="icl"
538                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
539             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
540                 export GRAPH_NODE_VARIANT="skx"
541                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
542             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
543                 export GRAPH_NODE_VARIANT="hsw"
544                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
545             fi
546         fi
547     fi
548 }
549
550
551 function installed () {
552
553     # Check if the given utility is installed. Fail if not installed.
554     #
555     # Duplicate of common.sh function, as this file is also used standalone.
556     #
557     # Arguments:
558     # - ${1} - Utility to check.
559     # Returns:
560     # - 0 - If command is installed.
561     # - 1 - If command is not installed.
562
563     set -exuo pipefail
564
565     command -v "${1}"
566 }
567
568
569 function move_archives () {
570
571     # Move archive directory to top of workspace, if not already there.
572     #
573     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
574     # but in some jobs CSIT_DIR is not same as WORKSPACE
575     # (e.g. under VPP_DIR). To simplify ci-management settings,
576     # we want to move the data to the top. We do not want simple copy,
577     # as ci-management is eager with recursive search.
578     #
579     # As some scripts may call this function multiple times,
580     # the actual implementation use copying and deletion,
581     # so the workspace gets "union" of contents (except overwrites on conflict).
582     # The consequence is empty ARCHIVE_DIR remaining after this call.
583     #
584     # As the source directory is emptied,
585     # the check for dirs being different is essential.
586     #
587     # Variables read:
588     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
589     #   Can be unset, then it speeds up manual testing.
590     # - ARCHIVE_DIR - Path to directory with content to be moved.
591     # Directories updated:
592     # - ${WORKSPACE}/archives/ - Created if does not exist.
593     #   Content of ${ARCHIVE_DIR}/ is moved.
594     # Functions called:
595     # - die - Print to stderr and exit.
596
597     set -exuo pipefail
598
599     if [[ -n "${WORKSPACE-}" ]]; then
600         target=$(readlink -f "${WORKSPACE}/archives")
601         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
602             mkdir -p "${target}" || die "Archives dir create failed."
603             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
604             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
605         fi
606     fi
607 }
608
609
610 function reserve_and_cleanup_testbed () {
611
612     # Reserve physical testbed, perform cleanup, register trap to unreserve.
613     # When cleanup fails, remove from topologies and keep retrying
614     # until all topologies are removed.
615     #
616     # Variables read:
617     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
618     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
619     # - BUILD_TAG - Any string suitable as filename, identifying
620     #   test run executing this function. May be unset.
621     # Variables set:
622     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
623     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
624     # Functions called:
625     # - die - Print to stderr and exit.
626     # - ansible_playbook - Perform an action using ansible, see ansible.sh
627     # Traps registered:
628     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
629
630     set -exuo pipefail
631
632     while true; do
633         for topo in "${TOPOLOGIES[@]}"; do
634             set +e
635             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
636             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
637             python3 "${scrpt}" "${opts[@]}"
638             result="$?"
639             set -e
640             if [[ "${result}" == "0" ]]; then
641                 # Trap unreservation before cleanup check,
642                 # so multiple jobs showing failed cleanup improve chances
643                 # of humans to notice and fix.
644                 WORKING_TOPOLOGY="${topo}"
645                 echo "Reserved: ${WORKING_TOPOLOGY}"
646                 trap "untrap_and_unreserve_testbed" EXIT || {
647                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
648                     untrap_and_unreserve_testbed "${message}" || {
649                         die "Teardown should have died, not failed."
650                     }
651                     die "Trap attempt failed, unreserve succeeded. Aborting."
652                 }
653                 # Cleanup + calibration checks
654                 set +e
655                 ansible_playbook "cleanup, calibration"
656                 result="$?"
657                 set -e
658                 if [[ "${result}" == "0" ]]; then
659                     break
660                 fi
661                 warn "Testbed cleanup failed: ${topo}"
662                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
663             fi
664             # Else testbed is accessible but currently reserved, moving on.
665         done
666
667         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
668             # Exit the infinite while loop if we made a reservation.
669             warn "Reservation and cleanup successful."
670             break
671         fi
672
673         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
674             die "Run out of operational testbeds!"
675         fi
676
677         # Wait ~3minutes before next try.
678         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
679             die "Sleep time calculation failed."
680         }
681         echo "Sleeping ${sleep_time}"
682         sleep "${sleep_time}" || die "Sleep failed."
683     done
684 }
685
686
687 function run_pybot () {
688
689     # Run pybot with options based on input variables. Create output_info.xml
690     #
691     # Variables read:
692     # - CSIT_DIR - Path to existing root of local CSIT git repository.
693     # - ARCHIVE_DIR - Path to store robot result files in.
694     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
695     # - GENERATED_DIR - Tests are assumed to be generated under there.
696     # Variables set:
697     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
698     # Functions called:
699     # - die - Print to stderr and exit.
700
701     set -exuo pipefail
702
703     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
704     all_options+=("--noncritical" "EXPECTED_FAILING")
705     all_options+=("${EXPANDED_TAGS[@]}")
706
707     pushd "${CSIT_DIR}" || die "Change directory operation failed."
708     set +e
709     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
710     PYBOT_EXIT_STATUS="$?"
711     set -e
712
713     # Generate INFO level output_info.xml for post-processing.
714     all_options=("--loglevel" "INFO")
715     all_options+=("--log" "none")
716     all_options+=("--report" "none")
717     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
718     all_options+=("${ARCHIVE_DIR}/output.xml")
719     rebot "${all_options[@]}" || true
720     popd || die "Change directory operation failed."
721 }
722
723
724 function select_arch_os () {
725
726     # Set variables affected by local CPU architecture and operating system.
727     #
728     # Variables set:
729     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
730     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
731     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
732
733     set -exuo pipefail
734
735     source /etc/os-release || die "Get OS release failed."
736
737     case "${ID}" in
738         "ubuntu"*)
739             case "${VERSION}" in
740                 *"LTS (Focal Fossa)"*)
741                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
742                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_FOCAL"
743                     PKG_SUFFIX="deb"
744                     ;;
745                 *)
746                     die "Unsupported Ubuntu version!"
747                     ;;
748             esac
749             ;;
750         *)
751             die "Unsupported distro or OS!"
752             ;;
753     esac
754
755     arch=$(uname -m) || {
756         die "Get CPU architecture failed."
757     }
758
759     case "${arch}" in
760         "aarch64")
761             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
762             ;;
763         *)
764             ;;
765     esac
766 }
767
768
769 function select_tags () {
770
771     # Variables read:
772     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
773     # - TEST_CODE - String affecting test selection, usually jenkins job name.
774     # - DUT - CSIT test/ subdirectory, set while processing tags.
775     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
776     #   Can be unset.
777     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
778     # - BASH_FUNCTION_DIR - Directory with input files to process.
779     # Variables set:
780     # - TAGS - Array of processed tag boolean expressions.
781     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
782
783     set -exuo pipefail
784
785     # NIC SELECTION
786     start_pattern='^  TG:'
787     end_pattern='^ \? \?[A-Za-z0-9]\+:'
788     # Remove the TG section from topology file
789     sed_command="/${start_pattern}/,/${end_pattern}/d"
790     # All topologies DUT NICs
791     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
792                 | grep -hoP "model: \K.*" | sort -u)
793     # Selected topology DUT NICs
794     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
795                | grep -hoP "model: \K.*" | sort -u)
796     # All topologies DUT NICs - Selected topology DUT NICs
797     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
798         die "Computation of excluded NICs failed."
799     }
800
801     # Select default NIC tag.
802     case "${TEST_CODE}" in
803         *"3n-dnv"* | *"2n-dnv"*)
804             default_nic="nic_intel-x553"
805             ;;
806         *"3n-tsh"*)
807             default_nic="nic_intel-x520-da2"
808             ;;
809         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
810             default_nic="nic_intel-xxv710"
811             ;;
812         *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
813             default_nic="nic_intel-xl710"
814             ;;
815         *"2n-aws"* | *"3n-aws"*)
816             default_nic="nic_amazon-nitro-50g"
817             ;;
818         *)
819             default_nic="nic_intel-x710"
820             ;;
821     esac
822
823     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
824     awk_nics_sub_cmd=""
825     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
826     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
827     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
828     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
829     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
830     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
831     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
832     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
833     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
834     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
835     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
836     awk_nics_sub_cmd+='else drv="";'
837     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
838
839     # Tag file directory shorthand.
840     tfd="${JOB_SPECS_DIR}"
841     case "${TEST_CODE}" in
842         # Select specific performance tests based on jenkins job type variable.
843         *"ndrpdr-weekly"* )
844             readarray -t test_tag_array <<< $(grep -v "#" \
845                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
846                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
847             SELECTION_MODE="--test"
848             ;;
849         *"mrr-daily"* )
850             readarray -t test_tag_array <<< $(grep -v "#" \
851                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
852                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
853             SELECTION_MODE="--test"
854             ;;
855         *"mrr-weekly"* )
856             readarray -t test_tag_array <<< $(grep -v "#" \
857                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
858                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
859             SELECTION_MODE="--test"
860             ;;
861         *"report-iterative"* )
862             test_sets=(${TEST_TAG_STRING//:/ })
863             # Run only one test set per run
864             report_file=${test_sets[0]}.md
865             readarray -t test_tag_array <<< $(grep -v "#" \
866                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
867                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
868             SELECTION_MODE="--test"
869             ;;
870         *"report-coverage"* )
871             test_sets=(${TEST_TAG_STRING//:/ })
872             # Run only one test set per run
873             report_file=${test_sets[0]}.md
874             readarray -t test_tag_array <<< $(grep -v "#" \
875                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
876                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
877             SELECTION_MODE="--test"
878             ;;
879         * )
880             if [[ -z "${TEST_TAG_STRING-}" ]]; then
881                 # If nothing is specified, we will run pre-selected tests by
882                 # following tags.
883                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
884                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
885                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
886                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
887                                 "!dot1q" "!drv_avf")
888             else
889                 # If trigger contains tags, split them into array.
890                 test_tag_array=(${TEST_TAG_STRING//:/ })
891             fi
892             SELECTION_MODE="--include"
893             ;;
894     esac
895
896     # Blacklisting certain tags per topology.
897     #
898     # Reasons for blacklisting:
899     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
900     # TODO: Add missing reasons here (if general) or where used (if specific).
901     case "${TEST_CODE}" in
902         *"2n-skx"*)
903             test_tag_array+=("!ipsechw")
904             ;;
905         *"3n-skx"*)
906             test_tag_array+=("!ipsechw")
907             # Not enough nic_intel-xxv710 to support double link tests.
908             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
909             ;;
910         *"2n-clx"*)
911             test_tag_array+=("!ipsechw")
912             ;;
913         *"2n-zn2"*)
914             test_tag_array+=("!ipsechw")
915             ;;
916         *"2n-dnv"*)
917             test_tag_array+=("!ipsechw")
918             test_tag_array+=("!memif")
919             test_tag_array+=("!srv6_proxy")
920             test_tag_array+=("!vhost")
921             test_tag_array+=("!vts")
922             test_tag_array+=("!drv_avf")
923             ;;
924         *"2n-tx2"*)
925             test_tag_array+=("!ipsechw")
926             ;;
927         *"3n-dnv"*)
928             test_tag_array+=("!memif")
929             test_tag_array+=("!srv6_proxy")
930             test_tag_array+=("!vhost")
931             test_tag_array+=("!vts")
932             test_tag_array+=("!drv_avf")
933             ;;
934         *"3n-tsh"*)
935             # 3n-tsh only has x520 NICs which don't work with AVF
936             test_tag_array+=("!drv_avf")
937             test_tag_array+=("!ipsechw")
938             ;;
939         *"3n-hsw"*)
940             test_tag_array+=("!drv_avf")
941             # All cards have access to QAT. But only one card (xl710)
942             # resides in same NUMA as QAT. Other cards must go over QPI
943             # which we do not want to even run.
944             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
945             ;;
946         *"2n-aws"* | *"3n-aws"*)
947             test_tag_array+=("!ipsechw")
948             ;;
949         *)
950             # Default to 3n-hsw due to compatibility.
951             test_tag_array+=("!drv_avf")
952             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
953             ;;
954     esac
955
956     # We will add excluded NICs.
957     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
958
959     TAGS=()
960     prefix=""
961
962     set +x
963     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
964         # Automatic prefixing for VPP jobs to limit the NIC used and
965         # traffic evaluation to MRR.
966         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
967             prefix="${prefix}mrrAND"
968         else
969             prefix="${prefix}mrrAND${default_nic}AND"
970         fi
971     fi
972     for tag in "${test_tag_array[@]}"; do
973         if [[ "${tag}" == "!"* ]]; then
974             # Exclude tags are not prefixed.
975             TAGS+=("${tag}")
976         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
977             # Badly formed tag expressions can trigger way too much tests.
978             set -x
979             warn "The following tag expression hints at bad trigger: ${tag}"
980             warn "Possible cause: Multiple triggers in a single comment."
981             die "Aborting to avoid triggering too many tests."
982         elif [[ "${tag}" == *"OR"* ]]; then
983             # If OR had higher precedence than AND, it would be useful here.
984             # Some people think it does, thus triggering way too much tests.
985             set -x
986             warn "The following tag expression hints at bad trigger: ${tag}"
987             warn "Operator OR has lower precedence than AND. Use space instead."
988             die "Aborting to avoid triggering too many tests."
989         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
990             # Empty and comment lines are skipped.
991             # Other lines are normal tags, they are to be prefixed.
992             TAGS+=("${prefix}${tag}")
993         fi
994     done
995     set -x
996 }
997
998
999 function select_topology () {
1000
1001     # Variables read:
1002     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1003     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
1004     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1005     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1006     # Variables set:
1007     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1008     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1009     # Functions called:
1010     # - die - Print to stderr and exit.
1011
1012     set -exuo pipefail
1013
1014     case_text="${NODENESS}_${FLAVOR}"
1015     case "${case_text}" in
1016         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
1017         # TODO: Double link availability depends on NIC used.
1018         "1n_vbox")
1019             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1020             TOPOLOGIES_TAGS="2_node_single_link_topo"
1021             ;;
1022         "1n_skx" | "1n_tx2")
1023             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1024             TOPOLOGIES_TAGS="2_node_single_link_topo"
1025             ;;
1026         "2n_skx")
1027             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1028             TOPOLOGIES_TAGS="2_node_*_link_topo"
1029             ;;
1030         "2n_zn2")
1031             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1032             TOPOLOGIES_TAGS="2_node_*_link_topo"
1033             ;;
1034         "3n_skx")
1035             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1036             TOPOLOGIES_TAGS="3_node_*_link_topo"
1037             ;;
1038         "2n_clx")
1039             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1040             TOPOLOGIES_TAGS="2_node_*_link_topo"
1041             ;;
1042         "2n_dnv")
1043             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1044             TOPOLOGIES_TAGS="2_node_single_link_topo"
1045             ;;
1046         "3n_dnv")
1047             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1048             TOPOLOGIES_TAGS="3_node_single_link_topo"
1049             ;;
1050         "3n_hsw")
1051             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1052             TOPOLOGIES_TAGS="3_node_single_link_topo"
1053             ;;
1054         "3n_tsh")
1055             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1056             TOPOLOGIES_TAGS="3_node_single_link_topo"
1057             ;;
1058         "2n_tx2")
1059             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1060             TOPOLOGIES_TAGS="2_node_single_link_topo"
1061             ;;
1062         "2n_aws")
1063             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_aws*.yaml )
1064             TOPOLOGIES_TAGS="2_node_single_link_topo"
1065             ;;
1066         "3n_aws")
1067             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_aws*.yaml )
1068             TOPOLOGIES_TAGS="3_node_single_link_topo"
1069             ;;
1070         *)
1071             # No falling back to 3n_hsw default, that should have been done
1072             # by the function which has set NODENESS and FLAVOR.
1073             die "Unknown specification: ${case_text}"
1074     esac
1075
1076     if [[ -z "${TOPOLOGIES-}" ]]; then
1077         die "No applicable topology found!"
1078     fi
1079 }
1080
1081
1082 function select_vpp_device_tags () {
1083
1084     # Variables read:
1085     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1086     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1087     #   Can be unset.
1088     # Variables set:
1089     # - TAGS - Array of processed tag boolean expressions.
1090
1091     set -exuo pipefail
1092
1093     case "${TEST_CODE}" in
1094         # Select specific device tests based on jenkins job type variable.
1095         * )
1096             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1097                 # If nothing is specified, we will run pre-selected tests by
1098                 # following tags. Items of array will be concatenated by OR
1099                 # in Robot Framework.
1100                 test_tag_array=()
1101             else
1102                 # If trigger contains tags, split them into array.
1103                 test_tag_array=(${TEST_TAG_STRING//:/ })
1104             fi
1105             SELECTION_MODE="--include"
1106             ;;
1107     esac
1108
1109     # Blacklisting certain tags per topology.
1110     #
1111     # Reasons for blacklisting:
1112     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1113     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1114     case "${TEST_CODE}" in
1115         *"1n-vbox"*)
1116             test_tag_array+=("!avf")
1117             test_tag_array+=("!vhost")
1118             ;;
1119         *)
1120             ;;
1121     esac
1122
1123     TAGS=()
1124
1125     # We will prefix with devicetest to prevent running other tests
1126     # (e.g. Functional).
1127     prefix="devicetestAND"
1128     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1129         # Automatic prefixing for VPP jobs to limit testing.
1130         prefix="${prefix}"
1131     fi
1132     for tag in "${test_tag_array[@]}"; do
1133         if [[ ${tag} == "!"* ]]; then
1134             # Exclude tags are not prefixed.
1135             TAGS+=("${tag}")
1136         else
1137             TAGS+=("${prefix}${tag}")
1138         fi
1139     done
1140 }
1141
1142
1143 function set_environment_variables () {
1144
1145     # Depending on testbed topology, overwrite defaults set in the
1146     # resources/libraries/python/Constants.py file
1147     #
1148     # Variables read:
1149     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1150     # Variables set:
1151     # See specific cases
1152
1153     set -exuo pipefail
1154
1155     case "${TEST_CODE}" in
1156         *"2n-aws"* | *"3n-aws"*)
1157             # T-Rex 2.88 workaround for ENA NICs
1158             export TREX_RX_DESCRIPTORS_COUNT=1024
1159             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1160             # Settings to prevent duration stretching
1161             export PERF_TRIAL_STL_DELAY=0.1
1162             ;;
1163     esac
1164 }
1165
1166
1167 function untrap_and_unreserve_testbed () {
1168
1169     # Use this as a trap function to ensure testbed does not remain reserved.
1170     # Perhaps call directly before script exit, to free testbed for other jobs.
1171     # This function is smart enough to avoid multiple unreservations (so safe).
1172     # Topo cleanup is executed (call it best practice), ignoring failures.
1173     #
1174     # Hardcoded values:
1175     # - default message to die with if testbed might remain reserved.
1176     # Arguments:
1177     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1178     # Variables read (by inner function):
1179     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1180     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1181     # Variables written:
1182     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1183     # Trap unregistered:
1184     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1185     # Functions called:
1186     # - die - Print to stderr and exit.
1187     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1188
1189     set -xo pipefail
1190     set +eu  # We do not want to exit early in a "teardown" function.
1191     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1192     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1193     if [[ -z "${wt-}" ]]; then
1194         set -eu
1195         warn "Testbed looks unreserved already. Trap removal failed before?"
1196     else
1197         ansible_playbook "cleanup" || true
1198         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1199             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1200         }
1201         WORKING_TOPOLOGY=""
1202         set -eu
1203     fi
1204 }
1205
1206
1207 function warn () {
1208
1209     # Print the message to standard error.
1210     #
1211     # Arguments:
1212     # - ${@} - The text of the message.
1213
1214     set -exuo pipefail
1215
1216     echo "$@" >&2
1217 }